/******************************************************************************/
/* Copyright 2008-2009                                                        */
/*                                                                            */
/* File          : prec.c                                                     */
/*                                                                            */
/* Description   : This file is part of HIPS : Hierarchical Iterative         */
/*                 Parallel Solver (http://hips.gforge.inria.fr/).            */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* License       : CeCILL-C                                                   */
/*                                                                            */
/* This software is governed by the CeCILL-C license under French law and     */
/* abiding by the rules of distribution of free software. You can use,        */
/* modify and/or redistribute the software under the terms of the             */
/* CeCILL-C license as circulated by CEA, CNRS and INRIA at the following     */
/* URL: "http://www.cecill.info".                                             */
/*                                                                            */
/* As a counterpart to the access to the source code and rights to copy,      */
/* modify and redistribute granted by the license, users are provided         */
/* only with a limited warranty and the software's author, the holder of      */
/* the economic rights, and the successive licensors have only limited        */
/* liability.                                                                 */
/*                                                                            */
/* In this respect, the user's attention is drawn to the risks associated     */
/* with loading, using, modifying and/or developing or reproducing the        */
/* software by the user in light of its specific status of free software,     */
/* that may mean that it is complicated to manipulate, and that also          */
/* therefore means that it is reserved for developers and experienced         */
/* professionals having in-depth computer knowledge. Users are therefore      */
/* encouraged to load and test the software's suitability as regards          */
/* their requirements in conditions enabling the security of their            */
/* systems and/or data to be ensured and, more generally, to use and          */
/* operate it in the same conditions as regards security.                     */
/*                                                                            */
/* The fact that you are presently reading this means that you have had       */
/* knowledge of the CeCILL-C license and that you accept its terms.           */
/******************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#include "phidal_sequential.h"
#include "block.h"

#include "prec.h"


void Prec2PhidalPrec(Prec* p1, PhidalPrec* p2) {

  /* unused flag_t type; */

  p2->symmetric  = p1->symmetric;
  p2->dim        = p1->dim;
  p2->levelnum   = p1->levelnum;
  p2->forwardlev = p1->forwardlev;


/*   LU; */
/*   PhidalMatrix *L; */
/*   PhidalMatrix *U; */
/*   COEF *D; */

/*  EF; */
/*   PhidalMatrix *E; */
/*   PhidalMatrix *F; */

/*  EF_DB; /\* tmp, a suppr *\/ */

/*  p2->B = p1->B; */
/*   PhidalMatrix *B; */

/*  p2->S; */
/*   PhidalMatrix *S; */

 assert(p1->precprec == NULL);
 assert(p1->nextprec == NULL);
 p2->prevprec = NULL;
 p2->nextprec = NULL;

 p2->schur_method = p1->schur_method;
 p2->info         = p1->info;

 p2->pivoting = p1->pivoting; 
 p2->permtab  = p1-> permtab;

}


void PhidalPrec2Prec(PhidalPrec* p1, Prec* p2) {

  /* unused flag_t type; */

  p2->symmetric  = p1->symmetric;
  p2->dim        = p1->dim;
  p2->levelnum   = p1->levelnum;
  p2->forwardlev = p1->forwardlev;


/*   LU; */
/*   PhidalMatrix *L; */
/*   PhidalMatrix *U; */
/*   COEF *D; */

/*  EF; */
/*   PhidalMatrix *E; */
/*   PhidalMatrix *F; */

/*  EF_DB; /\* tmp, a suppr *\/ */

/*  p2->B = p1->B; */
/*   PhidalMatrix *B; */

/*  p2->S; */
/*   PhidalMatrix *S; */

 assert(p1->precprec == NULL);
 assert(p1->nextprec == NULL);
 p2->prevprec = NULL;
 p2->nextprec = NULL;

 p2->schur_method = p1->schur_method;
 p2->info         = p1->info;

 p2->pivoting = p1->pivoting; 
 p2->permtab  = p1-> permtab;

}
